/**
 * @license
 * MIT License
 * 
 * Copyright (c) 2014-present, Lee Byron and other contributors.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
!function(t,r){"object"==typeof exports&&"undefined"!=typeof module?r(exports):"function"==typeof define&&define.amd?define(["exports"],r):r((t="undefined"!=typeof globalThis?globalThis:t||self).Immutable={})}(this,(function(t){"use strict";var r="delete",e=5,n=1<<e,o=n-1,i={};function u(t){t&&(t.value=!0)}function a(){}function s(t,r){if("number"!=typeof r){var e=r>>>0;if(""+e!==r||4294967295===e)return NaN;r=e}return r<0?function(t){return void 0===t.size&&(t.size=t.__iterate(f)),t.size}(t)+r:r}function f(){return!0}function c(t,r,e){return void 0===t?e:h(t)?r===1/0?r:0|Math.max(0,r+t):void 0===r||r===t?t:0|Math.min(r,t)}function h(t){return t<0||0===t&&1/t==-1/0}var p="@@__IMMUTABLE_ITERABLE__@@";function _(t){return Boolean(t&&t[p])}var l="@@__IMMUTABLE_KEYED__@@";function y(t){return Boolean(t&&t[l])}var v="@@__IMMUTABLE_INDEXED__@@";function d(t){return Boolean(t&&t[v])}function w(t){return y(t)||d(t)}var g=function(t){return _(t)?t:K(t)},m=function(t){function r(t){return y(t)?t:W(t)}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r}(g),b=function(t){function r(t){return d(t)?t:J(t)}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r}(g),I=function(t){function r(t){return _(t)&&!w(t)?t:V(t)}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r}(g);g.Keyed=m,g.Indexed=b,g.Set=I;var E="@@__IMMUTABLE_SEQ__@@";var S="@@__IMMUTABLE_RECORD__@@";function O(t){return Boolean(t&&t[S])}function D(t){return _(t)||O(t)}var j="@@__IMMUTABLE_ORDERED__@@";function z(t){return Boolean(t&&t[j])}var A=0,M=1,k="function"==typeof Symbol&&Symbol.iterator,q="@@iterator",T=k||q,x=function(t){this.next=t};function B(t,r,e,n){var o=t===A?r:t===M?e:[r,e];return n?n.value=o:n={value:o,done:!1},n}function L(){return{value:void 0,done:!0}}function U(t){return!!Array.isArray(t)||!!H(t)}function C(t){return t&&"function"==typeof t.next}function P(t){var r=H(t);return r&&r.call(t)}function H(t){var r=t&&(k&&t[k]||t[q]);if("function"==typeof r)return r}x.prototype.toString=function(){return"[Iterator]"},x.KEYS=A,x.VALUES=M,x.ENTRIES=2,x.prototype.inspect=x.prototype.toSource=function(){return this.toString()},x.prototype[T]=function(){return this};var R=Object.prototype.hasOwnProperty;function N(t){return!(!Array.isArray(t)&&"string"!=typeof t)||t&&"object"==typeof t&&Number.isInteger(t.length)&&t.length>=0&&(0===t.length?1===Object.keys(t).length:t.hasOwnProperty(t.length-1))}var K=function(t){function r(t){return null==t?G():D(t)?t.toSeq():function(t){var r=Z(t);if(r)return(n=H(e=t))&&n===e.entries?r.fromEntrySeq():function(t){var r=H(t);return r&&r===t.keys}(t)?r.toSetSeq():r;var e,n;if("object"==typeof t)return new Q(t);throw new TypeError("Expected Array or collection object of values, or keyed object: "+t)}(t)}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.prototype.toSeq=function(){return this},r.prototype.toString=function(){return this.__toString("Seq {","}")},r.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},r.prototype.__iterate=function(t,r){var e=this._cache;if(e){for(var n=e.length,o=0;o!==n;){var i=e[r?n-++o:o++];if(!1===t(i[1],i[0],this))break}return o}return this.__iterateUncached(t,r)},r.prototype.__iterator=function(t,r){var e=this._cache;if(e){var n=e.length,o=0;return new x((function(){if(o===n)return{value:void 0,done:!0};var i=e[r?n-++o:o++];return B(t,i[0],i[1])}))}return this.__iteratorUncached(t,r)},r}(g),W=function(t){function r(t){return null==t?G().toKeyedSeq():_(t)?y(t)?t.toSeq():t.fromEntrySeq():O(t)?t.toSeq():function(t){var r=Z(t);if(r)return r.fromEntrySeq();if("object"==typeof t)return new Q(t);throw new TypeError("Expected Array or collection object of [k, v] entries, or keyed object: "+t)}(t)}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.prototype.toKeyedSeq=function(){return this},r}(K),J=function(t){function r(t){return null==t?G():_(t)?y(t)?t.entrySeq():t.toIndexedSeq():O(t)?t.toSeq().entrySeq():function(t){var r=Z(t);if(r)return r;throw new TypeError("Expected Array or collection object of values: "+t)}(t)}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.of=function(){return r(arguments)},r.prototype.toIndexedSeq=function(){return this},r.prototype.toString=function(){return this.__toString("Seq [","]")},r}(K),V=function(t){function r(t){return(_(t)&&!w(t)?t:J(t)).toSetSeq()}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.of=function(){return r(arguments)},r.prototype.toSetSeq=function(){return this},r}(K);K.isSeq=function(t){return Boolean(t&&t[E])},K.Keyed=W,K.Set=V,K.Indexed=J,K.prototype[E]=!0;var Y=function(t){function r(t){this._array=t,this.size=t.length}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.prototype.get=function(t,r){return this.has(t)?this._array[s(this,t)]:r},r.prototype.__iterate=function(t,r){for(var e=this._array,n=e.length,o=0;o!==n;){var i=r?n-++o:o++;if(!1===t(e[i],i,this))break}return o},r.prototype.__iterator=function(t,r){var e=this._array,n=e.length,o=0;return new x((function(){if(o===n)return{value:void 0,done:!0};var i=r?n-++o:o++;return B(t,i,e[i])}))},r}(J),Q=function(t){function r(t){var r=Object.keys(t).concat(Object.getOwnPropertySymbols?Object.getOwnPropertySymbols(t):[]);this._object=t,this._keys=r,this.size=r.length}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.prototype.get=function(t,r){return void 0===r||this.has(t)?this._object[t]:r},r.prototype.has=function(t){return R.call(this._object,t)},r.prototype.__iterate=function(t,r){for(var e=this._object,n=this._keys,o=n.length,i=0;i!==o;){var u=n[r?o-++i:i++];if(!1===t(e[u],u,this))break}return i},r.prototype.__iterator=function(t,r){var e=this._object,n=this._keys,o=n.length,i=0;return new x((function(){if(i===o)return{value:void 0,done:!0};var u=n[r?o-++i:i++];return B(t,u,e[u])}))},r}(W);Q.prototype[j]=!0;var X,F=function(t){function r(t){this._collection=t,this.size=t.length||t.size}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.prototype.__iterateUncached=function(t,r){if(r)return this.cacheResult().__iterate(t,r);var e=P(this._collection),n=0;if(C(e))for(var o;!(o=e.next()).done&&!1!==t(o.value,n++,this););return n},r.prototype.__iteratorUncached=function(t,r){if(r)return this.cacheResult().__iterator(t,r);var e=P(this._collection);if(!C(e))return new x(L);var n=0;return new x((function(){var r=e.next();return r.done?r:B(t,n++,r.value)}))},r}(J);function G(){return X||(X=new Y([]))}function Z(t){return N(t)?new Y(t):U(t)?new F(t):void 0}var $=Object.prototype.toString;function tt(t){if(!t||"object"!=typeof t||"[object Object]"!==$.call(t))return!1;var r=Object.getPrototypeOf(t);if(null===r)return!0;for(var e=r,n=Object.getPrototypeOf(r);null!==n;)e=n,n=Object.getPrototypeOf(e);return e===r}function rt(t,r,e,n,o,i){if("string"!=typeof e&&!D(e)&&(N(e)||U(e)||tt(e))){if(~t.indexOf(e))throw new TypeError("Cannot convert circular structure to Immutable");t.push(e),o&&""!==n&&o.push(n);var u=r.call(i,n,K(e).map((function(n,i){return rt(t,r,n,i,o,e)})),o&&o.slice());return t.pop(),o&&o.pop(),u}return e}function et(t,r){return d(r)?r.toList():y(r)?r.toMap():r.toSet()}var nt="@@__IMMUTABLE_LIST__@@";function ot(t){return Boolean(t&&t[nt])}function it(t){return"object"==typeof t&&(D(t)||Array.isArray(t)||tt(t))}function ut(t){try{return"string"==typeof t?JSON.stringify(t):String(t)}catch(r){return JSON.stringify(t)}}function at(t){return Boolean(t&&"function"==typeof t.equals&&"function"==typeof t.hashCode)}function st(t,r){if(t===r||t!=t&&r!=r)return!0;if(!t||!r)return!1;if("function"==typeof t.valueOf&&"function"==typeof r.valueOf){if((t=t.valueOf())===(r=r.valueOf())||t!=t&&r!=r)return!0;if(!t||!r)return!1}return!!(at(t)&&at(r)&&t.equals(r))}var ft="@@__IMMUTABLE_MAP__@@";function ct(t){return Boolean(t&&t[ft])}function ht(t){return t>>>1&1073741824|3221225471&t}var pt=Object.prototype.valueOf;function _t(t){if(null==t)return lt(t);if("function"==typeof t.hashCode)return ht(t.hashCode(t));var r,e=(r=t).valueOf!==pt&&"function"==typeof r.valueOf?r.valueOf(r):r;if(null==e)return lt(e);switch(typeof e){case"boolean":return e?1108378657:1108378656;case"number":return function(t){if(t!=t||t===1/0)return 0;var r=0|t;r!==t&&(r^=4294967295*t);for(;t>4294967295;)r^=t/=4294967295;return ht(r)}(e);case"string":return e.length>St?function(t){var r=jt[t];void 0===r&&(r=yt(t),Dt===Ot&&(Dt=0,jt={}),Dt++,jt[t]=r);return r}(e):yt(e);case"object":case"function":return function(t){var r;if(mt&&void 0!==(r=gt.get(t)))return r;if(r=t[Et],void 0!==r)return r;if(!dt){if(void 0!==(r=t.propertyIsEnumerable&&t.propertyIsEnumerable[Et]))return r;if(void 0!==(r=function(t){if(t&&t.nodeType>0)switch(t.nodeType){case 1:return t.uniqueID;case 9:return t.documentElement&&t.documentElement.uniqueID}}(t)))return r}if(r=wt(),mt)gt.set(t,r);else{if(void 0!==vt&&!1===vt(t))throw new Error("Non-extensible objects are not allowed as keys.");if(dt)Object.defineProperty(t,Et,{enumerable:!1,configurable:!1,writable:!1,value:r});else if(void 0!==t.propertyIsEnumerable&&t.propertyIsEnumerable===t.constructor.prototype.propertyIsEnumerable)t.propertyIsEnumerable=function(){return this.constructor.prototype.propertyIsEnumerable.apply(this,arguments)},t.propertyIsEnumerable[Et]=r;else{if(void 0===t.nodeType)throw new Error("Unable to set a non-enumerable property on object.");t[Et]=r}}return r}(e);case"symbol":return function(t){var r=bt[t];if(void 0!==r)return r;return r=wt(),bt[t]=r,r}(e);default:if("function"==typeof e.toString)return yt(e.toString());throw new Error("Value type "+typeof e+" cannot be hashed.")}}function lt(t){return null===t?1108378658:1108378659}function yt(t){for(var r=0,e=0;e<t.length;e++)r=31*r+t.charCodeAt(e)|0;return ht(r)}var vt=Object.isExtensible,dt=function(){try{return Object.defineProperty({},"@",{}),!0}catch(t){return!1}}();function wt(){var t=++It;return 1073741824&It&&(It=0),t}var gt,mt="function"==typeof WeakMap;mt&&(gt=new WeakMap);var bt=Object.create(null),It=0,Et="__immutablehash__";"function"==typeof Symbol&&(Et=Symbol(Et));var St=16,Ot=255,Dt=0,jt={};function zt(t){return ct(t)&&z(t)}function At(t){!function(t,r){if(!t)throw new Error(r)}(t!==1/0,"Cannot perform this action with an infinite size.")}var Mt,kt=function(t){function r(t){return null==t?Tt():zt(t)?t:Tt().withMutations((function(r){var e=m(t);At(e.size),e.forEach((function(t,e){return r.set(e,t)}))}))}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.of=function(){return this(arguments)},r.prototype.toString=function(){return this.__toString("OrderedMap {","}")},r.prototype.get=function(t,r){var e=this._map.get(t);return void 0!==e?this._list.get(e)[1]:r},r.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._map.clear(),this._list.clear(),this.__altered=!0,this):Tt()},r.prototype.set=function(t,r){return xt(this,t,r)},r.prototype.remove=function(t){return xt(this,t,i)},r.prototype.__iterate=function(t,r){var e=this;return this._list.__iterate((function(r){return r&&t(r[1],r[0],e)}),r)},r.prototype.__iterator=function(t,r){return this._list.fromEntrySeq().__iterator(t,r)},r.prototype.__ensureOwner=function(t){if(t===this.__ownerID)return this;var r=this._map.__ensureOwner(t),e=this._list.__ensureOwner(t);return t?qt(r,e,t,this.__hash):0===this.size?Tt():(this.__ownerID=t,this.__altered=!1,this._map=r,this._list=e,this)},r}(Zt);function qt(t,r,e,n){var o=Object.create(kt.prototype);return o.size=t?t.size:0,o._map=t,o._list=r,o.__ownerID=e,o.__hash=n,o.__altered=!1,o}function Tt(){return Mt||(Mt=qt(cr(),Mr()))}function xt(t,r,e){var o,u,a=t._map,s=t._list,f=a.get(r),c=void 0!==f;if(e===i){if(!c)return t;s.size>=n&&s.size>=2*a.size?(o=(u=s.filter((function(t,r){return void 0!==t&&f!==r}))).toKeyedSeq().map((function(t){return t[0]})).flip().toMap(),t.__ownerID&&(o.__ownerID=u.__ownerID=t.__ownerID)):(o=a.remove(r),u=f===s.size-1?s.pop():s.set(f,void 0))}else if(c){if(e===s.get(f)[1])return t;o=a,u=s.set(f,[r,e])}else o=a.set(r,s.size),u=s.set(s.size,[r,e]);return t.__ownerID?(t.size=o.size,t._map=o,t._list=u,t.__hash=void 0,t.__altered=!0,t):qt(o,u)}function Bt(t,r,e){r||(r=Lt);var n=y(t),o=0,i=t.toSeq().map((function(r,n){return[n,r,o++,e?e(r,n,t):r]})).valueSeq().toArray();return i.sort((function(t,e){return r(t[3],e[3])||t[2]-e[2]})).forEach(n?function(t,r){i[r].length=2}:function(t,r){i[r]=t[1]}),n?W(i):d(t)?J(i):V(i)}function Lt(t,r){return void 0===t&&void 0===r?0:void 0===t?1:void 0===r?-1:t>r?1:t<r?-1:0}function Ut(t,r){r=r||0;for(var e=Math.max(0,t.length-r),n=new Array(e),o=0;o<e;o++)n[o]=t[o+r];return n}function Ct(t){return function(t,r){return br(t,r,(function(){return i}))}(this,t)}function Pt(t,r,e,n){return br(t,[r],e,n)}function Ht(t,r,e){return 1===arguments.length?t(this):Pt(this,t,r,e)}function Rt(t,r,e){return br(this,t,r,e)}function Nt(t,r,e){for(var n=[],o=0;o<r.length;o++){var u=m(r[o]);0!==u.size&&n.push(u)}return 0===n.length?t:0!==t.toSeq().size||t.__ownerID||1!==n.length?t.withMutations((function(t){for(var r=e?function(r,n){Pt(t,n,i,(function(t){return t===i?r:e(t,r,n)}))}:function(r,e){t.set(e,r)},o=0;o<n.length;o++)n[o].forEach(r)})):t.constructor(n[0])}function Kt(t){if(Array.isArray(t))return Ut(t);var r={};for(var e in t)R.call(t,e)&&(r[e]=t[e]);return r}function Wt(t,r,e){return Jt(t,r,function(t){function r(e,n,o){return it(e)&&it(n)&&(i=n,u=K(e),a=K(i),d(u)===d(a)&&y(u)===y(a))?Jt(e,[n],r):t?t(e,n,o):n;var i,u,a}return r}(e))}function Jt(t,r,e){if(!it(t))throw new TypeError("Cannot merge into non-data-structure value: "+t);if(D(t))return"function"==typeof e&&t.mergeWith?t.mergeWith.apply(t,[e].concat(r)):t.merge?t.merge.apply(t,r):t.concat.apply(t,r);for(var n=Array.isArray(t),o=t,i=n?b:m,u=n?function(r){o===t&&(o=Kt(o)),o.push(r)}:function(r,n){var i=R.call(o,n),u=i&&e?e(o[n],r,n):r;i&&u===o[n]||(o===t&&(o=Kt(o)),o[n]=u)},a=0;a<r.length;a++)i(r[a]).forEach(u);return o}function Vt(t){for(var r=[],e=arguments.length-1;e-- >0;)r[e]=arguments[e+1];return br(this,t,cr(),(function(t){return Jt(t,r)}))}function Yt(t){for(var r=[],e=arguments.length-1;e-- >0;)r[e]=arguments[e+1];return br(this,t,cr(),(function(t){return Wt(t,r)}))}function Qt(t){var r=this.asMutable();return t(r),r.wasAltered()?r.__ensureOwner(this.__ownerID):this}function Xt(){return this.__ownerID?this:this.__ensureOwner(new a)}function Ft(){return this.__ensureOwner()}function Gt(){return this.__altered}kt.isOrderedMap=zt,kt.prototype[j]=!0,kt.prototype[r]=kt.prototype.remove;var Zt=function(t){function r(r){return null==r?cr():ct(r)&&!z(r)?r:cr().withMutations((function(e){var n=t(r);At(n.size),n.forEach((function(t,r){return e.set(r,t)}))}))}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.prototype.toString=function(){return this.__toString("Map {","}")},r.prototype.get=function(t,r){return this._root?this._root.get(0,void 0,t,r):r},r.prototype.set=function(t,r){return hr(this,t,r)},r.prototype.remove=function(t){return hr(this,t,i)},r.prototype.deleteAll=function(t){var r=g(t);return 0===r.size?this:this.withMutations((function(t){r.forEach((function(r){return t.remove(r)}))}))},r.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._root=null,this.__hash=void 0,this.__altered=!0,this):cr()},r.prototype.sort=function(t){return kt(Bt(this,t))},r.prototype.sortBy=function(t,r){return kt(Bt(this,r,t))},r.prototype.map=function(t,r){var e=this;return this.withMutations((function(n){n.forEach((function(o,i){n.set(i,t.call(r,o,i,e))}))}))},r.prototype.__iterator=function(t,r){return new ur(this,t,r)},r.prototype.__iterate=function(t,r){var e=this,n=0;return this._root&&this._root.iterate((function(r){return n++,t(r[1],r[0],e)}),r),n},r.prototype.__ensureOwner=function(t){return t===this.__ownerID?this:t?fr(this.size,this._root,t,this.__hash):0===this.size?cr():(this.__ownerID=t,this.__altered=!1,this)},r}(m);Zt.isMap=ct;var $t=Zt.prototype;$t[ft]=!0,$t[r]=$t.remove,$t.removeAll=$t.deleteAll,$t.setIn=Er,$t.removeIn=$t.deleteIn=Ct,$t.update=Ht,$t.updateIn=Rt,$t.merge=$t.concat=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];return Nt(this,t)},$t.mergeWith=function(t){for(var r=[],e=arguments.length-1;e-- >0;)r[e]=arguments[e+1];if("function"!=typeof t)throw new TypeError("Invalid merger function: "+t);return Nt(this,r,t)},$t.mergeDeep=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];return Wt(this,t)},$t.mergeDeepWith=function(t){for(var r=[],e=arguments.length-1;e-- >0;)r[e]=arguments[e+1];return Wt(this,r,t)},$t.mergeIn=Vt,$t.mergeDeepIn=Yt,$t.withMutations=Qt,$t.wasAltered=Gt,$t.asImmutable=Ft,$t["@@transducer/init"]=$t.asMutable=Xt,$t["@@transducer/step"]=function(t,r){return t.set(r[0],r[1])},$t["@@transducer/result"]=function(t){return t.asImmutable()};var tr=function(t,r){this.ownerID=t,this.entries=r};tr.prototype.get=function(t,r,e,n){for(var o=this.entries,i=0,u=o.length;i<u;i++)if(st(e,o[i][0]))return o[i][1];return n},tr.prototype.update=function(t,r,e,n,o,s,f){for(var c=o===i,h=this.entries,p=0,_=h.length;p<_&&!st(n,h[p][0]);p++);var l=p<_;if(l?h[p][1]===o:c)return this;if(u(f),(c||!l)&&u(s),!c||1!==h.length){if(!l&&!c&&h.length>=dr)return function(t,r,e,n){t||(t=new a);for(var o=new or(t,_t(e),[e,n]),i=0;i<r.length;i++){var u=r[i];o=o.update(t,0,void 0,u[0],u[1])}return o}(t,h,n,o);var y=t&&t===this.ownerID,v=y?h:Ut(h);return l?c?p===_-1?v.pop():v[p]=v.pop():v[p]=[n,o]:v.push([n,o]),y?(this.entries=v,this):new tr(t,v)}};var rr=function(t,r,e){this.ownerID=t,this.bitmap=r,this.nodes=e};rr.prototype.get=function(t,r,n,i){void 0===r&&(r=_t(n));var u=1<<((0===t?r:r>>>t)&o),a=this.bitmap;return 0==(a&u)?i:this.nodes[yr(a&u-1)].get(t+e,r,n,i)},rr.prototype.update=function(t,r,u,a,s,f,c){void 0===u&&(u=_t(a));var h=(0===r?u:u>>>r)&o,p=1<<h,_=this.bitmap,l=0!=(_&p);if(!l&&s===i)return this;var y=yr(_&p-1),v=this.nodes,d=l?v[y]:void 0,w=pr(d,t,r+e,u,a,s,f,c);if(w===d)return this;if(!l&&w&&v.length>=wr)return function(t,r,e,o,i){for(var u=0,a=new Array(n),s=0;0!==e;s++,e>>>=1)a[s]=1&e?r[u++]:void 0;return a[o]=i,new er(t,u+1,a)}(t,v,_,h,w);if(l&&!w&&2===v.length&&_r(v[1^y]))return v[1^y];if(l&&w&&1===v.length&&_r(w))return w;var g=t&&t===this.ownerID,m=l?w?_:_^p:_|p,b=l?w?vr(v,y,w,g):function(t,r,e){var n=t.length-1;if(e&&r===n)return t.pop(),t;for(var o=new Array(n),i=0,u=0;u<n;u++)u===r&&(i=1),o[u]=t[u+i];return o}(v,y,g):function(t,r,e,n){var o=t.length+1;if(n&&r+1===o)return t[r]=e,t;for(var i=new Array(o),u=0,a=0;a<o;a++)a===r?(i[a]=e,u=-1):i[a]=t[a+u];return i}(v,y,w,g);return g?(this.bitmap=m,this.nodes=b,this):new rr(t,m,b)};var er=function(t,r,e){this.ownerID=t,this.count=r,this.nodes=e};er.prototype.get=function(t,r,n,i){void 0===r&&(r=_t(n));var u=(0===t?r:r>>>t)&o,a=this.nodes[u];return a?a.get(t+e,r,n,i):i},er.prototype.update=function(t,r,n,u,a,s,f){void 0===n&&(n=_t(u));var c=(0===r?n:n>>>r)&o,h=a===i,p=this.nodes,_=p[c];if(h&&!_)return this;var l=pr(_,t,r+e,n,u,a,s,f);if(l===_)return this;var y=this.count;if(_){if(!l&&--y<gr)return function(t,r,e,n){for(var o=0,i=0,u=new Array(e),a=0,s=1,f=r.length;a<f;a++,s<<=1){var c=r[a];void 0!==c&&a!==n&&(o|=s,u[i++]=c)}return new rr(t,o,u)}(t,p,y,c)}else y++;var v=t&&t===this.ownerID,d=vr(p,c,l,v);return v?(this.count=y,this.nodes=d,this):new er(t,y,d)};var nr=function(t,r,e){this.ownerID=t,this.keyHash=r,this.entries=e};nr.prototype.get=function(t,r,e,n){for(var o=this.entries,i=0,u=o.length;i<u;i++)if(st(e,o[i][0]))return o[i][1];return n},nr.prototype.update=function(t,r,e,n,o,a,s){void 0===e&&(e=_t(n));var f=o===i;if(e!==this.keyHash)return f?this:(u(s),u(a),lr(this,t,r,e,[n,o]));for(var c=this.entries,h=0,p=c.length;h<p&&!st(n,c[h][0]);h++);var _=h<p;if(_?c[h][1]===o:f)return this;if(u(s),(f||!_)&&u(a),f&&2===p)return new or(t,this.keyHash,c[1^h]);var l=t&&t===this.ownerID,y=l?c:Ut(c);return _?f?h===p-1?y.pop():y[h]=y.pop():y[h]=[n,o]:y.push([n,o]),l?(this.entries=y,this):new nr(t,this.keyHash,y)};var or=function(t,r,e){this.ownerID=t,this.keyHash=r,this.entry=e};or.prototype.get=function(t,r,e,n){return st(e,this.entry[0])?this.entry[1]:n},or.prototype.update=function(t,r,e,n,o,a,s){var f=o===i,c=st(n,this.entry[0]);return(c?o===this.entry[1]:f)?this:(u(s),f?void u(a):c?t&&t===this.ownerID?(this.entry[1]=o,this):new or(t,this.keyHash,[n,o]):(u(a),lr(this,t,r,_t(n),[n,o])))},tr.prototype.iterate=nr.prototype.iterate=function(t,r){for(var e=this.entries,n=0,o=e.length-1;n<=o;n++)if(!1===t(e[r?o-n:n]))return!1},rr.prototype.iterate=er.prototype.iterate=function(t,r){for(var e=this.nodes,n=0,o=e.length-1;n<=o;n++){var i=e[r?o-n:n];if(i&&!1===i.iterate(t,r))return!1}},or.prototype.iterate=function(t,r){return t(this.entry)};var ir,ur=function(t){function r(t,r,e){this._type=r,this._reverse=e,this._stack=t._root&&sr(t._root)}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.prototype.next=function(){for(var t=this._type,r=this._stack;r;){var e=r.node,n=r.index++,o=void 0;if(e.entry){if(0===n)return ar(t,e.entry)}else if(e.entries){if(n<=(o=e.entries.length-1))return ar(t,e.entries[this._reverse?o-n:n])}else if(n<=(o=e.nodes.length-1)){var i=e.nodes[this._reverse?o-n:n];if(i){if(i.entry)return ar(t,i.entry);r=this._stack=sr(i,r)}continue}r=this._stack=this._stack.__prev}return{value:void 0,done:!0}},r}(x);function ar(t,r){return B(t,r[0],r[1])}function sr(t,r){return{node:t,index:0,__prev:r}}function fr(t,r,e,n){var o=Object.create($t);return o.size=t,o._root=r,o.__ownerID=e,o.__hash=n,o.__altered=!1,o}function cr(){return ir||(ir=fr(0))}function hr(t,r,e){var n,o;if(t._root){var u={value:!1},a={value:!1};if(n=pr(t._root,t.__ownerID,0,void 0,r,e,u,a),!a.value)return t;o=t.size+(u.value?e===i?-1:1:0)}else{if(e===i)return t;o=1,n=new tr(t.__ownerID,[[r,e]])}return t.__ownerID?(t.size=o,t._root=n,t.__hash=void 0,t.__altered=!0,t):n?fr(o,n):cr()}function pr(t,r,e,n,o,a,s,f){return t?t.update(r,e,n,o,a,s,f):a===i?t:(u(f),u(s),new or(r,n,[o,a]))}function _r(t){return t.constructor===or||t.constructor===nr}function lr(t,r,n,i,u){if(t.keyHash===i)return new nr(r,i,[t.entry,u]);var a,s=(0===n?t.keyHash:t.keyHash>>>n)&o,f=(0===n?i:i>>>n)&o,c=s===f?[lr(t,r,n+e,i,u)]:(a=new or(r,i,u),s<f?[t,a]:[a,t]);return new rr(r,1<<s|1<<f,c)}function yr(t){return t=(t=(858993459&(t-=t>>1&1431655765))+(t>>2&858993459))+(t>>4)&252645135,t+=t>>8,127&(t+=t>>16)}function vr(t,r,e,n){var o=n?t:Ut(t);return o[r]=e,o}var dr=n/4,wr=n/2,gr=n/4;function mr(t,r,e){return D(t)?t.get(r,e):function(t,r){return D(t)?t.has(r):it(t)&&R.call(t,r)}(t,r)?"function"==typeof t.get?t.get(r):t[r]:e}function br(t,r,e,n){n||(n=e,e=void 0);var o=Ir(D(t),t,function(t){if(N(t)&&"string"!=typeof t)return t;if(z(t))return t.toArray();throw new TypeError("Invalid keyPath: expected Ordered Collection or Array: "+t)}(r),0,e,n);return o===i?e:o}function Ir(t,r,e,n,o,u){var a=r===i;if(n===e.length){var s=a?o:r,f=u(s);return f===s?r:f}if(!a&&!it(r))throw new TypeError("Cannot update within non-data-structure value in path ["+e.slice(0,n).map(ut)+"]: "+r);var c=e[n],h=a?i:mr(r,c,i),p=Ir(h===i?t:D(h),h,e,n+1,o,u);return p===h?r:p===i?function(t,r){if(!it(t))throw new TypeError("Cannot update non-data-structure value: "+t);if(D(t)){if(!t.remove)throw new TypeError("Cannot update immutable value without .remove() method: "+t);return t.remove(r)}if(!R.call(t,r))return t;var e=Kt(t);return Array.isArray(e)?e.splice(r,1):delete e[r],e}(r,c):function(t,r,e){if(!it(t))throw new TypeError("Cannot update non-data-structure value: "+t);if(D(t)){if(!t.set)throw new TypeError("Cannot update immutable value without .set() method: "+t);return t.set(r,e)}if(R.call(t,r)&&e===t[r])return t;var n=Kt(t);return n[r]=e,n}(a?t?cr():{}:r,c,p)}function Er(t,r){return function(t,r,e){return br(t,r,i,(function(){return e}))}(this,t,r)}var Sr=function(t){function r(r){var o=Mr();if(null==r)return o;if(ot(r))return r;var i=t(r),u=i.size;return 0===u?o:(At(u),u>0&&u<n?Ar(0,u,e,null,new Dr(i.toArray())):o.withMutations((function(t){t.setSize(u),i.forEach((function(r,e){return t.set(e,r)}))})))}return t&&(r.__proto__=t),r.prototype=Object.create(t&&t.prototype),r.prototype.constructor=r,r.of=function(){return this(arguments)},r.prototype.toString=function(){return this.__toString("List [","]")},r.prototype.get=function(t,r){if((t=s(this,t))>=0&&t<this.size){var e=Tr(this,t+=this._origin);return e&&e.array[t&o]}return r},r.prototype.set=function(t,r){return function(t,r,e){if(r=s(t,r),r!=r)return t;if(r>=t.size||r<0)return t.withMutations((function(t){r<0?xr(t,r).set(0,e):xr(t,0,r+1).set(r,e)}));r+=t._origin;var n=t._tail,o=t._root,i={value:!1};r>=Br(t._capacity)?n=kr(n,t.__ownerID,0,r,e,i):o=kr(o,t.__ownerID,t._level,r,e,i);if(!i.value)return t;if(t.__ownerID)return t._root=o,t._tail=n,t.__hash=void 0,t.__altered=!0,t;return Ar(t._origin,t._capacity,t._level,o,n)}(this,t,r)},r.prototype.remove=function(t){return this.has(t)?0===t?this.shift():t===this.size-1?this.pop():this.splice(t,1):this},r.prototype.insert=function(t,r){return this.splice(t,0,r)},r.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=this._origin=this._capacity=0,this._level=e,this._root=this._tail=this.__hash=void 0,this.__altered=!0,this):Mr()},r.prototype.push=function(){var t=arguments,r=this.size;return this.withMutations((function(e){xr(e,0,r+t.length);for(var n=0;n<t.length;n++)e.set(r+n,t[n])}))},r.prototype.pop=function(){return xr(this,0,-1)},r.prototype.unshift=function(){var t=arguments;return this.withMutations((function(r){xr(r,-t.length);for(var e=0;e<t.length;e++)r.set(e,t[e])}))},r.prototype.shift=function(){return xr(this,1)},r.prototype.concat=function(){for(var r=arguments,e=[],n=0;n<arguments.length;n++){var o=r[n],i=t("string"!=typeof o&&U(o)?o:[o]);0!==i.size&&e.push(i)}return 0===e.length?this:0!==this.size||this.__ownerID||1!==e.length?this.withMutations((function(t){e.forEach((function(r){return r.forEach((function(r){return t.push(r)}))}))})):this.constructor(e[0])},r.prototype.setSize=function(t){return xr(this,0,t)},r.prototype.map=function(t,r){var e=this;return this.withMutations((function(n){for(var o=0;o<e.size;o++)n.set(o,t.call(r,n.get(o),o,e))}))},r.prototype.slice=function(t,r){var e=this.size;return function(t,r,e){return(0===t&&!h(t)||void 0!==e&&t<=-e)&&(void 0===r||void 0!==e&&r>=e)}(t,r,e)?this:xr(this,function(t,r){return c(t,r,0)}(t,e),function(t,r){return c(t,r,r)}(r,e))},r.prototype.__iterator=function(t,r){var e=r?this.size:0,n=zr(this,r);return new x((function(){var o=n();return o===jr?{value:void 0,done:!0}:B(t,r?--e:e++,o)}))},r.prototype.__iterate=function(t,r){for(var e,n=r?this.size:0,o=zr(this,r);(e=o())!==jr&&!1!==t(e,r?--n:n++,this););return n},r.prototype.__ensureOwner=function(t){return t===this.__ownerID?this:t?Ar(this._origin,this._capacity,this._level,this._root,this._tail,t,this.__hash):0===this.size?Mr():(this.__ownerID=t,this.__altered=!1,this)},r}(b);Sr.isList=ot;var Or=Sr.prototype;Or[nt]=!0,Or[r]=Or.remove,Or.merge=Or.concat,Or.setIn=Er,Or.deleteIn=Or.removeIn=Ct,Or.update=Ht,Or.updateIn=Rt,Or.mergeIn=Vt,Or.mergeDeepIn=Yt,Or.withMutations=Qt,Or.wasAltered=Gt,Or.asImmutable=Ft,Or["@@transducer/init"]=Or.asMutable=Xt,Or["@@transducer/step"]=function(t,r){return t.push(r)},Or["@@transducer/result"]=function(t){return t.asImmutable()};var Dr=function(t,r){this.array=t,this.ownerID=r};Dr.prototype.removeBefore=function(t,r,n){if(0==(n&(1<<r+e)-1)||0===this.array.length)return this;var i=n>>>r&o;if(i>=this.array.length)return new Dr([],t);var u,a=0===i;if(r>0){var s=this.array[i];if((u=s&&s.removeBefore(t,r-e,n))===s&&a)return this}if(a&&!u)return this;var f=qr(this,t);if(!a)for(var c=0;c<i;c++)f.array[c]=void 0;return u&&(f.array[i]=u),f},Dr.prototype.removeAfter=function(t,r,i){if(i===(r?1<<r+e:n)||0===this.array.length)return this;var u,a=i-1>>>r&o;if(a>=this.array.length)return this;if(r>0){var s=this.array[a];if((u=s&&s.removeAfter(t,r-e,i))===s&&a===this.array.length-1)return this}var f=qr(this,t);return f.array.splice(a+1),u&&(f.array[a]=u),f};var jr={};function zr(t,r){var o=t._origin,i=t._capacity,u=Br(i),a=t._tail;return s(t._root,t._level,0);function s(t,f,c){return 0===f?function(t,e){var s=e===u?a&&a.array:t&&t.array,f=e>o?0:o-e,c=i-e;c>n&&(c=n);return function(){if(f===c)return jr;var t=r?--c:f++;return s&&s[t]}}(t,c):function(t,u,a){var f,c=t&&t.array,h=a>o?0:o-a>>u,p=1+(i-a>>u);p>n&&(p=n);return function(){for(;;){if(f){var t=f();if(t!==jr)return t;f=null}if(h===p)return jr;var n=r?--p:h++;f=s(c&&c[n],u-e,a+(n<<u))}}}(t,f,c)}}function Ar(t,r,e,n,o,i,u){var a=Object.create(Or);return a.size=r-t,a._origin=t,a._capacity=r,a._level=e,a._root=n,a._tail=o,a.__ownerID=i,a.__hash=u,a.__altered=!1,a}function Mr(){return Ar(0,0,e)}function kr(t,r,n,i,a,s){var f,c=i>>>n&o,h=t&&c<t.array.length;if(!h&&void 0===a)return t;if(n>0){var p=t&&t.array[c],_=kr(p,r,n-e,i,a,s);return _===p?t:((f=qr(t,r)).array[c]=_,f)}return h&&t.array[c]===a?t:(s&&u(s),f=qr(t,r),void 0===a&&c===f.array.length-1?f.array.pop():f.array[c]=a,f)}function qr(t,r){return r&&t&&r===t.ownerID?t:new Dr(t?t.array.slice():[],r)}function Tr(t,r){if(r>=Br(t._capacity))return t._tail;if(r<1<<t._level+e){for(var n=t._root,i=t._level;n&&i>0;)n=n.array[r>>>i&o],i-=e;return n}}function xr(t,r,n){void 0!==r&&(r|=0),void 0!==n&&(n|=0);var i=t.__ownerID||new a,u=t._origin,s=t._capacity,f=u+r,c=void 0===n?s:n<0?s+n:u+n;if(f===u&&c===s)return t;if(f>=c)return t.clear();for(var h=t._level,p=t._root,_=0;f+_<0;)p=new Dr(p&&p.array.length?[void 0,p]:[],i),_+=1<<(h+=e);_&&(f+=_,u+=_,c+=_,s+=_);for(var l=Br(s),y=Br(c);y>=1<<h+e;)p=new Dr(p&&p.array.length?[p]:[],i),h+=e;var v=t._tail,d=y<l?Tr(t,c-1):y>l?new Dr([],i):v;if(v&&y>l&&f<s&&v.array.length){for(var w=p=qr(p,i),g=h;g>e;g-=e){var m=l>>>g&o;w=w.array[m]=qr(w.array[m],i)}w.array[l>>>e&o]=v}if(c<s&&(d=d&&d.removeAfter(i,0,c)),f>=y)f-=y,c-=y,h=e,p=null,d=d&&d.removeBefore(i,0,f);else if(f>u||y<l){for(_=0;p;){var b=f>>>h&o;if(b!==y>>>h&o)break;b&&(_+=(1<<h)*b),h-=e,p=p.array[b]}p&&f>u&&(p=p.removeBefore(i,h,f-_)),p&&y<l&&(p=p.removeAfter(i,h,y-_)),_&&(f-=_,c-=_)}return t.__ownerID?(t.size=c-f,t._origin=f,t._capacity=c,t._level=h,t._root=p,t._tail=d,t.__hash=void 0,t.__altered=!0,t):Ar(f,c,h,p,d)}function Br(t){return t<n?0:t-1>>>e<<e}t.List=Sr,t.Map=Zt,t.fromJS=function(t,r){return rt([],r||et,t,"",r&&r.length>2?[]:void 0,{"":t})}}));
